'use strict';

var fs = require('fs');
var path = require('path');

var _require = require('axway-flow-schema'),
    flowschema = _require.v2;

var schemas = require('axway-schema');
var FlowManager = require('./flowmanager');

// setup schema
schemas.register(flowschema).loadSync();

function register(flowManager) {
	fs.readdirSync(path.join(__dirname, 'nodehandlers')).forEach(function (fname) {
		// strip the name from the .js file and use it as part of a require path.
		var type = fname.replace(/\.js$/, '');
		var uri = FlowManager.formatNodeHandlerUri('axway-flow', type);
		// eslint-disable-next-line security/detect-non-literal-require
		var handlerModule = require(path.join(__dirname, 'nodehandlers', type));
		flowManager.registerNode(uri, handlerModule.handler, handlerModule.spec);
	});
}

function unregister(flowManager) {
	fs.readdirSync(path.join(__dirname, 'nodehandlers')).forEach(function (fname) {
		// strip the name from the .js file and use it as part of a require path.
		var type = fname.replace(/\.js$/, '');
		var uri = FlowManager.formatNodeHandlerUri('axway-flow', type);
		flowManager.unregisterNode(uri);
	});
}

exports = module.exports = {
	FlowManager: FlowManager,
	FlowNode: require('./flownode'),
	register: register,
	unregister: unregister
};